
#include "blob.h"
#include "ofMain.h"
#define OF_ADDON_USING_OFXVECTORMATH
#include "ofAddons.h"


//---------------------------------------------------------------------
blob::blob(){
	
	centerPoint.x=0;
	centerPoint.y=0;
	
	randomTime = ofRandom(0.2, 0.7);

}

//---------------------------------------------------------------------
void blob::make(){
	
	float position = ofRandom(0,ofGetHeight());
			
	for (int i = 0; i < 50; i++){
		particle myParticle;
		
		float x = ofRandom(position,position+10) + 100 * cos ( (i / 200.0) * TWO_PI);
		float y = ofRandom(position,position+10) + 100 * sin ( (i / 200.0) * TWO_PI);
		
		myParticle.setInitialCondition(x,y ,0,0);
		particles.push_back(myParticle);
		
		mouthPos.x += x;
		mouthPos.y += y;
	}
	
	// change this to
	// for (int i = 0; i < 10; i++){
	// to see a chain
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 4;
		mySpring.springiness	= 0.2f;
		mySpring.particleA = & (particles[i  ]);
		mySpring.particleB = & (particles[(i+1) % particles.size()]);
		springs.push_back(mySpring);
	}
	
	blinkTime = ofRandom(280, 350);
	
	mouthPos.x = mouthPos.x/50;
	mouthPos.y = mouthPos.y/50;
	myMouth.make(mouthPos.x,mouthPos.y);

}

//---------------------------------------------------------------------
void blob::update(float mouseX, float mouseY){
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addRepulsionForce(mouseX, mouseY, 200, 0.7f);
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 50, 0.1);
		}
	}
	
	float sinOfTime = sin(ofGetElapsedTimef()*randomTime);
	float newRadius	= ofMap(sinOfTime, 0, 1, 4, 7);
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].distance = newRadius;
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	myEyeOne.update(particles[0].pos.x,particles[0].pos.y, mouseX, mouseY, blinkTime);
	myEyeTwo.update(particles[3].pos.x,particles[3].pos.y, mouseX, mouseY, blinkTime);
	
	for (int i=0; i<particles.size(); i++) {
		centerPoint.x += particles[i].pos.x;
		centerPoint.y += particles[i].pos.y;
	}
	
	centerPoint.x = centerPoint.x/particles.size();
	centerPoint.y = centerPoint.y/particles.size();
	
	for (int i = 0; i < particles.size(); i++){
		myMouth.update(centerPoint.x, centerPoint.y, particles[i].pos.x, particles[i].pos.y);
	}

	
}
//---------------------------------------------------------------------
void blob::beginUpdate(){

	// reset forces!
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
};   


//---------------------------------------------------------------------
void blob::endUpdate(){

	// add damping, add forces
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
};     

//---------------------------------------------------------------------
void blob::draw(int r, int g, int b, int alpha){
		
	myColor.r = r;
	myColor.g = g;
	myColor.b = b;
	
	
//	for (int i = 0; i < particles.size(); i++){
//		particles[i].draw();
//	}
//	
//	for (int i = 0; i < springs.size(); i++){
//		springs[i].draw();
//	}
	
	
	ofEnableAlphaBlending();
	ofBeginShape();
	ofSetColor(myColor.r, myColor.g, myColor.b, alpha);
	for (int i=0; i<particles.size(); i++) {
		ofVertex(particles[i].pos.x, particles[i].pos.y);
	}
	ofEndShape();
	ofDisableAlphaBlending();

	myMouth.draw();	
	
	myEyeOne.draw(particles[0].pos.x,particles[0].pos.y);
	myEyeTwo.draw(particles[3].pos.x,particles[3].pos.y);	

}



