
#include "eye.h"
#define OF_ADDON_USING_OFXVECTORMATH


//---------------------------------------------------------------------
eye::eye(){
	
	radius = 10.0f;
	pupil.set(0,0);
	prevPupil.set(0,0);
	doBlink = false;
	counter = 0;
}

//---------------------------------------------------------------------
void eye::update(float x, float y, float mouseX, float mouseY, int blinkTime){
	
	blink = blinkTime;
	counter++;
	
	if (counter%blink == 0) {
		doBlink = !doBlink;
	} else if (counter%(blink+5) == 0) {
		doBlink = !doBlink;
	}
	
	pupil.x = x;
	pupil.y = y;
	
	distance.x = pupil.x - mouseX;
	distance.y = pupil.y - mouseY;
		
	prevPupil.x = pupil.x;
	prevPupil.y = pupil.y;
		
	if (counter>(blink+6)) {
		counter=0;
	}

}

//---------------------------------------------------------------------
void eye::draw(float x, float y){
	


	ofSetColor(255, 255, 255);
	ofCircle(x, y, radius);
	
	if(doBlink){
		ofSetColor(0, 0, 0);
		ofCircle(x, y, radius);
	}
	ofPushMatrix();
		//ofTranslate(x,y);
		float newPupilX = ofClamp(pupil.x, -x-100, x+100);
		float newPupilY = ofClamp(pupil.y, -y-100, y+100);
		ofSetColor(0, 0, 0);
		ofCircle(newPupilX,newPupilY, radius/2);
	ofPopMatrix();
	
}