

#include "mouth.h"

//---------------------------------------------------------------------
mouth::mouth(){
	
	centerPoint.x=0;
	centerPoint.y=0;
	
	randomTime = ofRandom(0.5, 1.0);
	
}

//---------------------------------------------------------------------
void mouth::make(float x, float y){
	
	centerPoint.x = x;
	centerPoint.y = y;
	
	for (int i = 0; i < 10; i++){
		
		float newX = centerPoint.x + 100 * cos ( (i / 10.0) * TWO_PI);
		float newY = centerPoint.y + 100 * sin ( (i / 10.0) * TWO_PI);
		particle myParticle;
		myParticle.setInitialCondition(newX,newY ,0,0);
		particles.push_back(myParticle);
	}
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 4;
		mySpring.springiness	= 0.6f;
		mySpring.particleA = & (particles[i  ]);
		mySpring.particleB = & (particles[(i+1) % particles.size()]);
		springs.push_back(mySpring);
	}
	
}

//---------------------------------------------------------------------
void mouth::update(float x, float y, float x2, float y2){
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addAttractionForce(x, y, 40, 0.35f);
		particles[i].addRepulsionForce(x2, y2, 30, 0.35f);
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 50, 0.1);
		}
	}
	
	float sinOfTime = sin(ofGetElapsedTimef()*randomTime);
	float newRadius	= ofMap(sinOfTime, 0, 1, 5, 7);
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].distance = newRadius;
	}
		
		for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	// add damping, add forces
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	centerPoint.x = x;
	centerPoint.y = y;

}

//---------------------------------------------------------------------
void mouth::draw(){
	
ofEnableAlphaBlending();
ofBeginShape();
ofSetColor(0,0,0,100);
for (int i=0; i<particles.size(); i++) {
	ofVertex(particles[i].pos.x, particles[i].pos.y);
}
ofEndShape();
ofDisableAlphaBlending();
	//ofCircle(centerPoint.x, centerPoint.y, 10);

}

