#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	ofBackground(0, 0, 0);
	
	NF.setup();
	NF.scaleOfField = 0.007;
	bPressed = false;
	
	ofSetCircleResolution(30);
	numberofBlobs = 5;
	
	for (int i=0; i<numberofBlobs; i++) {
		blob * myBlob = new blob;
		blobs.push_back(myBlob);
	}
	
	for (int i=0; i<blobs.size(); i++) {
		blobs[i]->make();
	}
		
//	#ifdef _USE_LIVE_VIDEO
//		vidGrabber.setVerbose(true);
//		vidGrabber.initGrabber(320,240);
//	#else
//		vidPlayer.loadMovie("movie.m4v");
//		vidPlayer.play();
//	#endif
//		
//    colorImg.allocate(320,240);
//	grayImage.allocate(320,240);
//	grayBg.allocate(320,240);
//	grayDiff.allocate(320,240);
//	
//	bLearnBakground = true;
//	threshold = 30;
//	bDrawDiagnostic = true;
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	NF.setTime(ofGetElapsedTimef()*0.001);

	for (int i=0; i<blobs.size(); i++) {
		blobs[i]->beginUpdate();
		blobs[i]->update(mouseX, mouseY);
		//blobs[i]->endUpdate();
	}
	
	//noise vector field
	for (int i = 0; i < blobs.size(); i++){
		for (int j=0; j<blobs[i]->particles.size(); j++) {
			if (bPressed){
				blobs[i]->particles[j].addAttractionForce(mouseX, mouseY, 2000,0.1);
				ofxVec2f frcFromNoise = NF.getNoiseForPosition(blobs[i]->particles[j].pos.x, blobs[i]->particles[j].pos.y,0.1);
				blobs[i]->particles[j].addForce(frcFromNoise.x, frcFromNoise.y);
			}
		}
	}
	
	//atempt to repel blobs away from eachother
	for (int i=0; i<blobs.size(); i++){
		for (int j = 0; j<i; j++) {
			for (int k=0; k<blobs[i]->particles.size(); k++) {
				for (int l=0; l<blobs[j]->particles.size(); l++) {
					blobs[i]->particles[k].addRepulsionForce(blobs[j]->particles[l].pos.x,blobs[j]->particles[l].pos.y,50,0.8f);
				}
			}
		}
	}
	
	//int radius = 100;
//	for (int i=0; i<blobs.size(); i++) {
//		for (int j=0; j<i; j++) {
//			//float distance;
//			//distance = ofDist(blobs[i]->centerPoint.x, blobs[i]->centerPoint.y, blobs[j]->centerPoint.x, blobs[j]->centerPoint.y);
//			//if (distance < radius) {
//				for (int k=0; k<blobs[i]->particles.size(); k++) {
//					blobs[i]->particles[k].addRepulsionForce(blobs[j]->centerPoint.x,blobs[j]->centerPoint.y,100,2.3f);
//				}
//			/*		drawNoise = true;
//			} else {
//				drawNoise = false;
//			}*/
//
//		}
//	}
	
	for (int i=0; i<blobs.size(); i++) {
		blobs[i]->endUpdate();
	}


		
	//----------------------------------------------------- video stuff
	bool bNewFrame = false;
	
	#ifdef _USE_LIVE_VIDEO
		vidGrabber.grabFrame();
		bNewFrame = vidGrabber.isFrameNew();
	#else
		vidPlayer.idleMovie();
		bNewFrame = vidPlayer.isFrameNew();
	#endif
	
	if (bNewFrame){
		
		#ifdef _USE_LIVE_VIDEO
				colorImg.setFromPixels(vidGrabber.getPixels(), 320,240);
				colorImg.mirror(false, true);
		#else
				colorImg.setFromPixels(vidPlayer.getPixels(), 320,240);
		#endif
		
        grayImage = colorImg;
		if (bLearnBakground == true){
			grayBg = grayImage;		// the = sign copys the pixels from grayImage into grayBg (operator overloading)
			bLearnBakground = false;
		}
		
		// take the abs value of the difference between background and incoming and then threshold:
		grayDiff.absDiff(grayBg, grayImage);
		grayDiff.threshold(threshold);
		contourFinder.findContours(grayDiff, 25,grayDiff.width * grayDiff.height, 1, false, false);
		
		contourParticles.clear();
		if (contourFinder.nBlobs > 0){
			
			for (int i = 0; i < contourFinder.blobs[0].nPts; i+=4){
			//for (int i = 0; i < (particles.size()*4); i+=4){
				
				float scaleX = (float) ofGetWidth() / (float)grayDiff.width;
				float scaleY = (float) ofGetHeight() / (float)grayDiff.height;
				particle p;
				p.setInitialCondition( contourFinder.blobs[0].pts[i].x*scaleX, contourFinder.blobs[0].pts[i].y*scaleY, 0, 0);
				//p.setInitialCondition( i*20, 500, 0, 0);
				p.radius = 5;
				contourParticles.push_back(p);
				//printf("%i \n", contourParticles.size());

			}
		}
	}
	
	
	//----------------------------------------------------- particle stuff
	

	
	// particle v particle
	for (int i = 0; i < particles.size(); i++){
		unsigned int bitFlagH_pta = particles[i].bitFlagH;
		unsigned int bitFlagW_pta = particles[i].bitFlagW;
		for (int j = 0; j < i; j++){
			unsigned int bitFlagH_ptb = particles[j].bitFlagH;
			unsigned int bitFlagW_ptb = particles[j].bitFlagW;
			if ((bitFlagW_pta & bitFlagW_ptb) && (bitFlagH_pta & bitFlagH_ptb)){
				particles[i].addRepulsionForce( particles[j],20,0.7);
			}
        }
    }
	
	
	// do particle against hand: 
	for (int i = 0; i < particles.size(); i++){
		unsigned int bitFlagH_pta = particles[i].bitFlagH;
		unsigned int bitFlagW_pta = particles[i].bitFlagW;
		for (int j = 0; j < contourParticles.size(); j++){
			unsigned int bitFlagH_ptb = contourParticles[j].bitFlagH;
			unsigned int bitFlagW_ptb = contourParticles[j].bitFlagW;
			if ((bitFlagW_pta & bitFlagW_ptb) && (bitFlagH_pta & bitFlagH_ptb)){
				particles[i].addRepulsionForce(contourParticles[j].pos.x, contourParticles[j].pos.y, 30, 0.01f);
			}
		}
	}
	

	//attract partcles to contour particles
//	for (int i = 0; i < contourParticles.size(); i+=4){
//		particles[i/4].addAttractionForce(contourParticles[i].pos.x, contourParticles[i].pos.x, 3000, 1.8f);
//		}

}

//--------------------------------------------------------------
void testApp::draw(){
	
	for (int i=0; i<blobs.size(); i++) {
		blobs[i]->draw(50, i*25, i*20, 255-(i*10));
	}
	
	
	//	for (int i=0; i<blobs.size(); i++) {
//		blobs[i]->draw(50, i*25, i*20, 255-(i*10));
//		for (int k=0; k<blobs[i]->particles.size();k++){
//		ofSetColor(255, 255, 255);
//			blobs[i]->particles[k].draw();
//		}
//	}
	
		
	
	//control panel
	ofFill();
		
	if (bDrawDiagnostic == true){
		
		// draw the incoming, the grayscale, the bg and the thresholded difference
		ofSetColor(0xffffff);
		colorImg.draw(20,20);	
		grayImage.draw(360,20);
		grayBg.draw(20,280);
		grayDiff.draw(360,280);
		
		ofSetColor(0,130,130, 200);
		ofRect(10,550,330,130);
		ofSetColor(0,0,0);
		ofDrawBitmapString("press ' ' (space) to snap background\npress 'd' to toggle diagnostic\ndrag mouse to add particles\npress 'r' to reset particles\npress 't' to toggle force direction", 20, 600);
				
	}
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	if (key == ' ' ){
		bLearnBakground = true;
	} else if (key == 'd'){	
		bDrawDiagnostic = !bDrawDiagnostic;
	} else if (key == 'r'){
		for (int i = 0; i < particles.size(); i++){
			particles[i].setInitialCondition(ofRandom(0,ofGetWidth()), ofRandom(0,ofGetHeight()), 0,0);
		}
	} else if (key == 'q') {
		bPressed = !bPressed;
	} 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
//	particles.erase(particles.begin());
//	particle pt;
//	pt.setInitialCondition(x, y, 0, 0);
//	particles.push_back(pt);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){


}
